﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TestApp
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
 
#if DEBUG
            Control.CheckForIllegalCrossThreadCalls = false;
#endif

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            txtEndPointAddress.Text = Properties.Settings.Default.EndPointAddress;
            txtCertificationCD.Text = Properties.Settings.Default.CertificationCD;
            txtPTimes.Enabled = false;
            txtPreReceiptNum.Enabled = false;
            cmbReceipt.SelectedIndex = 1;
            cmbUsePayID.SelectedIndex = 1;
            cbAutoCharge.Checked = false;
            gbAutoCharge.Enabled = false;
            dateAC_NextDate.Value = Convert.ToDateTime(DateTime.Now.AddMonths(1).ToString("yyyy/MM/01"));
            dateInqDate.Value = DateTime.Now;
            cmbInqMethod.SelectedIndex = 0;
        }
        private void btnPayment_Click_1(object sender, EventArgs e)
        {
            InputCheck oInputCheck = new InputCheck();
            txtX_RegistDate.Clear();
            txtX_Merchant.Clear();
            txtX_MerchantTel.Clear();
            txtX_TermCode.Clear();
            txtX_OrderID.Clear();
            txtX_ReceiptNum.Clear();
            txtX_RefApproved.Clear();
            txtX_RefForwarded.Clear();
            txtX_RefForwardedName.Clear();
            txtX_Card.Clear();
            txtX_Expire.Clear();
            txtX_CardBrand.Clear();
            txtX_AID.Clear();
            txtX_ApplicationLabel.Clear();
            txtX_MemberID.Clear();
            txtX_PayID.Clear();
            txtMessage.Clear();
            txtX_Signature.Clear();


            /* 入力チェック */
            if(txtEndPointAddress.Text.Length == 0) {
                MessageBox.Show("エンドポイントを入力してください",
                    "エラー",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
                return;
            }
            if (txtCertificationCD.Text.Length == 0)
            {
                MessageBox.Show("認証コードを入力してください",
                    "エラー",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
                return;
            }
            if ((txtOrderID.Text.Length == 0) || (!oInputCheck.IsAlphanumeric(txtOrderID.Text)))
            {
                MessageBox.Show("注文番号は半角英数字で入力してください",
                "エラー",
                MessageBoxButtons.OK,
                MessageBoxIcon.Error);
                return;
            }
            if ((txtAmount.Enabled) && (!oInputCheck.IsNumeric(txtAmount.Text)))
            {
                MessageBox.Show("金額は半角数字で入力してください",
                "エラー",
                MessageBoxButtons.OK,
                MessageBoxIcon.Error);
                return;
            }
            if(cmbJob.SelectedIndex == -1)
            {
                MessageBox.Show("処理区分を選択してください",
                    "エラー",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
                return;
            }
            if(cmbMethod.Enabled && (cmbMethod.SelectedIndex == -1))
            {
                MessageBox.Show("支払区分を選択してください",
                    "エラー",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
                return;
            }
            if ((txtPTimes.Enabled) && (!oInputCheck.IsNumeric(txtPTimes.Text)))
            {
                MessageBox.Show("分割回数は半角数字で入力してください",
                "エラー",
                MessageBoxButtons.OK,
                MessageBoxIcon.Error);
                return;
            }
            if(txtPreReceiptNum.Enabled && (txtPreReceiptNum.Text.Length == 0))
            {
                MessageBox.Show("取消対象レシート番号を入力してください",
                "エラー",
                MessageBoxButtons.OK,
                MessageBoxIcon.Error);
                return;
            }
            if(cbAutoCharge.Checked)
            {
                if ((txtAC_Name.Text.Length > 0) && (!oInputCheck.IsZenkaku(txtAC_Name.Text)))
                {
                    MessageBox.Show("会員名は全角で入力してください",
                    "エラー",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
                    return;
                }
                if ((txtAC_Name_Kana.Text.Length == 0) || (!oInputCheck.IsZenkakuKana(txtAC_Name_Kana.Text)))
                {
                    MessageBox.Show("会員名カナは全角カタカナで入力してください",
                    "エラー",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
                    return;
                }
                if((txtAC_Tel.Text.Length > 0) && (!oInputCheck.IsNumeric(txtAC_Tel.Text)))
                {
                    MessageBox.Show("電話番号は半角数字(ハイフンなし)で入力してください",
                    "エラー",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
                    return;
                }
                if ((txtAC_MAIL.Text.Length > 0) && (!oInputCheck.IsMailAddr(txtAC_MAIL.Text)))
                {
                    MessageBox.Show("Eメールアドレスを正しく入力してください",
                    "エラー",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
                    return;
                }
                if ((txtAC_Amount.Text.Length == 0) || (!oInputCheck.IsNumeric(txtAC_Amount.Text)))
                {
                    MessageBox.Show("金額は半角英数字で入力してください",
                    "エラー",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
                    return;
                }
                if(dateAC_NextDate.Value < DateTime.Now)
                {
                    MessageBox.Show("次回課金日は明日以降で入力してください",
                    "エラー",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
                    return;
                }
                if ((txtAC_Count.Text.Length > 0) && (!oInputCheck.IsNumeric(txtAC_Count.Text)))
                {
                    MessageBox.Show("課金回数は半角英数字で入力してください",
                    "エラー",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
                    return;
                }
            }
            btnPayment.Enabled = false;
            axpCATWebConnectorActiveX1.Init();
            axpCATWebConnectorActiveX1.EndPointAddress = txtEndPointAddress.Text;
            axpCATWebConnectorActiveX1.CertficationCD = txtCertificationCD.Text;
            axpCATWebConnectorActiveX1.OrderID = txtOrderID.Text;
            if(txtAmount.Text.Length > 0)
                axpCATWebConnectorActiveX1.Amount = Int32.Parse(txtAmount.Text);
            switch (cmbJob.Text) {
                case "カード有効性判定":
                    axpCATWebConnectorActiveX1.Job = "CHECK";
                    break;
                case "売上":
                    axpCATWebConnectorActiveX1.Job = "CAPTURE";
                    break;
                case "取消":
                    axpCATWebConnectorActiveX1.Job = "VOID";
                    axpCATWebConnectorActiveX1.PreReceiptNum = txtPreReceiptNum.Text;
                    break;
                case "返品":
                    axpCATWebConnectorActiveX1.Job = "RETURN";
                    axpCATWebConnectorActiveX1.PreReceiptNum = txtPreReceiptNum.Text;
                    break;
            }
            switch(cmbMethod.Text)
            {
                case "一括払い":
                    axpCATWebConnectorActiveX1.Method = "10";
                    break;
                case "分割払い":
                    axpCATWebConnectorActiveX1.Method = "61";
                    axpCATWebConnectorActiveX1.PTimes = Int32.Parse(txtPTimes.Text);
                    break;
                case "リボルビング払い":
                    axpCATWebConnectorActiveX1.Method = "80";
                    break;
            }
            if (cmbReceipt.Text == "発行する")
                axpCATWebConnectorActiveX1.Receipt = true;
            else
                axpCATWebConnectorActiveX1.Receipt = false;
            if (cmbUsePayID.Text == "発行する")
                axpCATWebConnectorActiveX1.UsePayID = true;
            else
                axpCATWebConnectorActiveX1.UsePayID = false;

            if (cbAutoCharge.Checked)
            {
                axpCATWebConnectorActiveX1.AutoCharge = true;
                axpCATWebConnectorActiveX1.Remarks = txtRemarks.Text;
                axpCATWebConnectorActiveX1.AC_Name = txtAC_Name.Text;
                axpCATWebConnectorActiveX1.AC_Name_Kana = txtAC_Name_Kana.Text;
                axpCATWebConnectorActiveX1.AC_Tel = txtAC_Tel.Text;
                axpCATWebConnectorActiveX1.AC_MAIL = txtAC_MAIL.Text;
                if(txtAC_Amount.Text.Length > 0)
                    axpCATWebConnectorActiveX1.AC_Amount = Int32.Parse(txtAC_Amount.Text);
                axpCATWebConnectorActiveX1.AC_NextDate = dateAC_NextDate.Value.ToString("yyyyMMdd");
                if(txtAC_Interval.Text.Length > 0)
                    axpCATWebConnectorActiveX1.AC_Interval = Int32.Parse(txtAC_Interval.Text);
                if (cmbAC_Interval_Unit.Text == "日")
                    axpCATWebConnectorActiveX1.AC_Interval_Unit = "D";
                else
                    axpCATWebConnectorActiveX1.AC_Interval_Unit = "M";
                if (txtAC_Count.Text.Length > 0)
                    axpCATWebConnectorActiveX1.AC_Count = Int32.Parse(txtAC_Count.Text);
                else
                    axpCATWebConnectorActiveX1.AC_Count = 0;
            }
            else
                axpCATWebConnectorActiveX1.AutoCharge = false;

            axpCATWebConnectorActiveX1.Opt1 = txtOpt1.Text;
            axpCATWebConnectorActiveX1.Opt2 = txtOpt2.Text;
            axpCATWebConnectorActiveX1.Opt3 = txtOpt3.Text;
            axpCATWebConnectorActiveX1.Opt4 = txtOpt4.Text;
            axpCATWebConnectorActiveX1.Opt5 = txtOpt5.Text;

            axpCATWebConnectorActiveX1.Connect();
        }

        private void axpCATWebConnectorActiveX1_OnConnected(object sender, EventArgs e)
        {
            if (tabControl1.SelectedIndex == 0)
                axpCATWebConnectorActiveX1.Authorize();
            else
                axpCATWebConnectorActiveX1.OnlineCheckTransaction();
        }

        private void axpCATWebConnectorActiveX1_OnDisConnected(object sender, EventArgs e)
        {
            btnPayment.Enabled = true;
            btnTranInquiry.Enabled = true;
            txtMessage.Text =  "切断されました";
        }

        private void axpCATWebConnectorActiveX1_OnError(object sender, AxpCATWebConnectorActiveXLib._DpCATWebConnectorActiveXEvents_OnErrorEvent e)
        {
            MessageBox.Show(e.message,"エラー[" + e.errorcd + "]", MessageBoxButtons.OK, MessageBoxIcon.Error);
            // （重要）エラーコードが以下の場合、決済は正常に完了していますので注意が必要です。
            //  2019    決済は成功したが、決済結果の取得時に例外が発生
            //  2020    決済は成功したが、PayIDの取得に失敗
            //  2024    決済は成功したが、レシートの印刷に失敗    
            txtMessage.Clear();
            btnPayment.Enabled = true;
            btnTranInquiry.Enabled = true;

        }

        private void axpCATWebConnectorActiveX1_OnMessage(object sender, AxpCATWebConnectorActiveXLib._DpCATWebConnectorActiveXEvents_OnMessageEvent e)
        {
            txtMessage.Text = "[" + e.statuscd + "] " + e.message;
        }

        private void axpCATWebConnectorActiveX1_OnSuccess(object sender, AxpCATWebConnectorActiveXLib._DpCATWebConnectorActiveXEvents_OnSuccessEvent e)
        {
            if(e.method == "Authorize")
            {
                txtX_RegistDate.Text = axpCATWebConnectorActiveX1.X_RegistDate;
                txtX_Merchant.Text = axpCATWebConnectorActiveX1.X_Merchant;
                txtX_MerchantTel.Text = axpCATWebConnectorActiveX1.X_MerchantTel;
                txtX_TermCode.Text = axpCATWebConnectorActiveX1.X_TermCode;
                txtX_OrderID.Text = axpCATWebConnectorActiveX1.X_OrderID;
                txtX_ReceiptNum.Text = axpCATWebConnectorActiveX1.X_ReceiptNum;
                txtX_RefApproved.Text = axpCATWebConnectorActiveX1.X_RefApproved;
                txtX_RefForwarded.Text = axpCATWebConnectorActiveX1.X_RefForwarded;
                txtX_RefForwardedName.Text = axpCATWebConnectorActiveX1.X_RefForwardedName;
                txtX_Card.Text = axpCATWebConnectorActiveX1.X_Card;
                txtX_Expire.Text = axpCATWebConnectorActiveX1.X_Expire.Substring(2, 2) + "年" +
                    axpCATWebConnectorActiveX1.X_Expire.Substring(0, 2) + "月";
                txtX_CardBrand.Text = axpCATWebConnectorActiveX1.X_CardBrand;
                txtX_AID.Text = axpCATWebConnectorActiveX1.X_AID;
                txtX_ApplicationLabel.Text = axpCATWebConnectorActiveX1.X_ApplicationLabel;
                txtX_MemberID.Text = axpCATWebConnectorActiveX1.X_AC_MemberID;
                txtX_PayID.Text = axpCATWebConnectorActiveX1.X_PayID;
                if (axpCATWebConnectorActiveX1.X_Signature)
                    txtX_Signature.Text = "必要";
                else
                    txtX_Signature.Text = "不要";
                Properties.Settings.Default.EndPointAddress = txtEndPointAddress.Text;
                Properties.Settings.Default.CertificationCD = txtCertificationCD.Text;
                Properties.Settings.Default.Save();
            }
            else
            {
                txtLog.Text = axpCATWebConnectorActiveX1.X_ResData;
                btnTranInquiry.Enabled = true;
            }
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            axpCATWebConnectorActiveX1.Exit();
        }

        private void cmbJob_SelectedIndexChanged(object sender, EventArgs e)
        {
            if((cmbJob.Text == "返品") || (cmbJob.Text == "取消"))
            {
                txtAmount.Enabled = true;
                cmbMethod.SelectedIndex = -1;
                cmbMethod.Enabled = false;
                cmbUsePayID.SelectedIndex = -1;
                cmbUsePayID.Enabled = false;
                txtPreReceiptNum.Enabled = true;
                cbAutoCharge.Checked = false;
                cbAutoCharge.Enabled = false;
            }
            else if(cmbJob.Text == "カード有効性判定")
            {
                txtAmount.Clear();
                txtAmount.Enabled = false;
                cmbMethod.SelectedIndex = -1;
                cmbMethod.Enabled = false;
                cmbUsePayID.Enabled = true;
            }
            else
            {
                txtAmount.Enabled = true;
                cmbMethod.Enabled = true;
                cmbMethod.SelectedIndex = 0;
                cmbUsePayID.Enabled = true;
                txtPreReceiptNum.Clear();
                txtPreReceiptNum.Enabled = false;
                cbAutoCharge.Enabled = true;
            }

        }

        private void cmbMethod_SelectedIndexChanged(object sender, EventArgs e)
        {
            if(cmbMethod.Text == "分割払い")
                txtPTimes.Enabled = true;
            else
            {
                txtPTimes.Clear();
                txtPTimes.Enabled = false;
            }
        }

        private void cbAutoCharge_CheckedChanged(object sender, EventArgs e)
        {
            if (cbAutoCharge.Checked)
                gbAutoCharge.Enabled = true;
            else
                gbAutoCharge.Enabled = false;
        }

        private void cbAutoCharge_EnabledChanged(object sender, EventArgs e)
        {
            cbAutoCharge_CheckedChanged(sender, e);
        }

        private void gbAutoCharge_EnabledChanged(object sender, EventArgs e)
        {
            if (!gbAutoCharge.Enabled){
                txtRemarks.Clear();
                txtAC_Name.Clear();
                txtAC_Name_Kana.Clear();
                txtAC_Tel.Clear();
                txtAC_MAIL.Clear();
                txtAC_Amount.Clear();
                dateAC_NextDate.Value = Convert.ToDateTime(DateTime.Now.AddMonths(1).ToString("yyyy/MM/01"));
                txtAC_Interval.Clear();
                cmbAC_Interval_Unit.SelectedIndex = -1;
                txtAC_Count.Clear();
            }
        }
        private void cmbInqMethod_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cmbInqMethod.Text == "オンライン取引ログ")
            {
                cmbInqReceipt.SelectedIndex = -1;
                cmbInqReceipt.Enabled = false;
            }
            else
                cmbInqReceipt.Enabled = true;
                
        }
        private void btnTranInquiry_Click(object sender, EventArgs e)
        {
            InputCheck oInputCheck = new InputCheck();
            txtLog.Clear();
            if (txtEndPointAddress.Text.Length == 0)
            {
                MessageBox.Show("エンドポイントを入力してください",
                    "エラー",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
                return;
            }
            if (txtCertificationCD.Text.Length == 0)
            {
                MessageBox.Show("認証コードを入力してください",
                    "エラー",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
                return;
            }
            if ((txtInqOrderID.Text.Length == 0) && (txtInqReceiptNum.Text.Length == 0))
            {
                MessageBox.Show("注文番号もしくはレシート番号を入力してください",
                    "エラー",
                    MessageBoxButtons.OK,
                    MessageBoxIcon.Error);
                return;
            }
            if (!oInputCheck.IsAlphanumeric(txtInqOrderID.Text))
            {
                MessageBox.Show("注文番号は半角英数字で入力してください",
                "エラー",
                MessageBoxButtons.OK,
                MessageBoxIcon.Error);
                return;
            }
            btnPayment.Enabled = false;
            axpCATWebConnectorActiveX1.Init();
            axpCATWebConnectorActiveX1.EndPointAddress = txtEndPointAddress.Text;
            axpCATWebConnectorActiveX1.CertficationCD = txtCertificationCD.Text;
            axpCATWebConnectorActiveX1.OrderID = txtInqOrderID.Text;
            axpCATWebConnectorActiveX1.SearchReceiptNum = txtInqReceiptNum.Text;
            axpCATWebConnectorActiveX1.SearchRegistDate = dateInqDate.Value.ToString("yyyy/MM/dd");
            btnTranInquiry.Enabled = false;
            if(cmbInqMethod.Text == "オンライン取引ログ")
                axpCATWebConnectorActiveX1.Connect();
            else
            {
                if (cmbInqReceipt.Text == "発行する")
                    axpCATWebConnectorActiveX1.Receipt = true;
                axpCATWebConnectorActiveX1.LogCheckTransaction();
            }
        } 
    }
}
